<?php
	define("SHOW_DB", "pacsdb");		// DCM4CHEE database
	define("SHOW_USER", "pacs");		// database user
	define("SHOW_PASSWORD", "pacs");	// user's password

	/* Requires to define supported request list */
	$supportedRequests = array('aid', 'study');


	function externalAuthentication()
	{
		global $authDB;

		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			if (isset($_GET['aid']))
			{
				$patient = getPID((string) $_GET['aid']);
				if ($patient != $_SESSION['login_patient'])
				{
					$_SESSION['login_patient'] = $patient;
					$authDB->logoff();
				}
			}
			else
			{
				$authDB->logoff();
			}
		}
		else
			if (isset($_SESSION['login_study']) && $_SESSION['login_study'] != "")
			{
				if (isset($_GET['study']))
				{
					$study = (string) $_GET['study'];
					if ($study != $_SESSION['login_study'])
					{
						$_SESSION['login_study'] = $study;
						$authDB->logoff();
					}
				}
				else
				{
					if (isset($_POST['study']))
					{
						$study = (string) $_POST['study'];
						if ($study != $_SESSION['login_study'])
						{
							$_SESSION['login_study'] = $study;
							$authDB->logoff();
						}
					}
					else
					{
						if (isset($_SESSION['login_post']))
						{
							unset($_SESSION['login_post']);
						}
						else
						{
							$authDB->logoff();
						}
					}
				}
			}
			else
			{
				if (isset($_GET['aid']) || isset($_REQUEST['study']))
				{
					$authDB->logoff();
				}
			}
	}


	function externalLoginInfo(&$db, &$user, &$password)
	{
		//-------------------

		$showpatient_enabled = true;

		//-------------------

		$_SESSION['login_patient'] = "";
		$_SESSION['login_username'] = "";
		$_SESSION['login_usergroup'] = "";
		unset($_SESSION['login_study']);
		unset($_SESSION['login_study_key']);

		if ($showpatient_enabled)
		{
			global $authDB, $audit;

			if (isset($_GET['aid']))
			{
				unset($_SESSION['aid']);

				$aid = (string) $_GET['aid'];
				$patient = getPID($aid);
				if (($patient != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_patient'] = $patient;
					$audit->log("SUCCESS, patient '$patient'", "aid '$aid'");
				}
				else
				{
					$audit->log(false, "aid '$aid', " . $authDB->formatConnectDetails('', ''));
				}
				return;
			}

			if (isset($_POST['aid']))
			{
				$aid = (string) $_POST['aid'];
				$patient = getPID($aid);
				if (($patient != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_post_patient'] = $patient;
					$audit->log("SUCCESS, patient '$patient'", "aid '$aid'");
				}
				else
				{
					$audit->log(false, "aid '$aid', " . $authDB->formatConnectDetails('', ''));
				}
				return;
			}
			else
				if (isset($_GET['study']))
				{
					$study = (string) $_GET['study'];
					if (($study != "") && (isset($user)) && ($user == ""))
					{
						$db = SHOW_DB;
						$user = SHOW_USER;
						$password = SHOW_PASSWORD;
						$_SESSION['login_study'] = $study;
						if (!check_study_uid($study, $key, $message, $fatal))
						{
							$db = "";
							$user = "";
							$password = "";
							unset($_GET['study']);
							unset($_SESSION['login_study']);
							unset($_SESSION['login_study_key']);
							$audit->log(false, "study '$study', " . $authDB->formatConnectDetails('', ''));
							$authDB->goHome(true, $message, $fatal, $study, 'study');
							exit;
						}
						else
						{
							$_SESSION['login_study_key'] = $key;
							$audit->log("SUCCESS, key '$key'", "study '$study'");
						}
					}
				}
				else
					if (isset($_POST['study']))
					{
						$study = (string) $_POST['study'];
						if (($study != "") && (isset($user)) && ($user == ""))
						{
							$db = SHOW_DB;
							$user = SHOW_USER;
							$password = SHOW_PASSWORD;
							$_SESSION['login_study'] = $study;
							$_SESSION['login_post'] = true;
							if (!check_study_uid($study, $key, $message, $fatal))
							{
								$db = "";
								$user = "";
								$password = "";
								unset($_POST['study']);
								unset($_SESSION['login_study']);
								unset($_SESSION['login_study_key']);
								$audit->log(false, "study '$study', " . $authDB->formatConnectDetails('', ''));
								$authDB->goHome(true, $message, $fatal, $study, 'study');
								exit;
							}
							else
							{
								$_SESSION['login_study_key'] = $key;
								$audit->log("SUCCESS, key '$key'", "study '$study'");
							}
						}
					}
		}
	}


	function externalPrivileges(&$privileges)
	{
		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			//$privileges['controlbar'] = false;
			$privileges['username'] = "";
			$privileges['closebutton'] = true;
			return;
		}

		if (isset($_SESSION['login_post_patient']) && ($_SESSION['login_post_patient'] != ""))
		{
			//$privileges['controlbar'] = false;
			$privileges['username'] = "";
			$privileges['closebutton'] = true;
			return;
		}
	}


	function externalActions(&$actions)
	{
		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "patient";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_patient'];
			return;
		}
		
		if (isset($_SESSION['login_post_patient']) && ($_SESSION['login_post_patient'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "patient";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_post_patient'];
			return;
		}

		if (isset($_SESSION['login_study']) && ($_SESSION['login_study'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "study";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_study_key'];
			return;
		}
	}


	function getPID($aid)
	{
		global $log;

		$link = @mssql_connect('POLIS', 'vytaut', 'vytaut123');
		if ($link === false)
		{
			$msg = mssql_get_last_message();
			$log->asErr("external/mssql_connect: $msg");
			return '';
		}
		if (@!mssql_select_db('polis', $link))
		{
			$msg = mssql_get_last_message();
			$log->asErr("external/mssql_select_db: $msg");
			return '';
		}

		try
		{
			$query = @mssql_query("SELECT TOP 1 ASM_ID,ASM_AK,ASM_PAVARDE,ASM_VARDAS FROM asmenys WHERE ASM_ID='".addslashes($aid)."' ORDER BY ASM_ID", $link);
		}
		catch (Exception $e)
		{
			$query = NULL;
		}
		if (!$query)
		{
			$msg = mssql_get_last_message();
			$log->asErr("external/mssql_query: $msg");
			return '';
		}

		$pid = '';
		$row = @mssql_fetch_row($query);
		if ($row)
			$pid = $row[1];

		@mssql_free_result($query);
		return $pid;
	}


	function check_study_uid($uid, &$key, &$err, &$fatal)
	{
		global $authDB, $log;

		$key = NULL;
		$err = '';
		$fatal = 0;

		if (!$authDB->connect(SHOW_DB, SHOW_USER, SHOW_PASSWORD))
		{
			$err = 'errorValidateConnect';
			$fatal = 2;
			/*
				If SHOW_USER or SHOW_PASSWORD is invalid, only administrator
				can fix that by editing this file; can't offer the login
				form as credentials from it are used later and elsewhere.

				Error message is logged in AuthDB::connect().
			 */
			return false;
		}
		if (strpos($uid, '.') !== false)
			$sql = "SELECT pk FROM study WHERE study_iuid='" . $authDB->sqlEscapeString($uid) . "'";
		else
			$sql = "SELECT pk FROM study WHERE pk='" . $authDB->sqlEscapeString($uid) . "'";
		$rs = $authDB->query($sql);
		if (!$rs)
		{
			$log->asErr("external/query: '" . $authDB->getError() . "'");
			$err = 'errorValidateQuery';
			$fatal = 1;
			return false;
		}
		$row = $authDB->fetchNum($rs);
		if (!$row)
		{
			$err = 'errorObjNotFound';
			return false;
		}
		$key = $row[0];

		return true;
	}
?>
