<?php
	define('SHOW_DB', 'dcm4chee');
	define('SHOW_USER', 'p4csNF');
	define('SHOW_PASSWORD', 'p4csNF');

	/* Requires to define supported request list */
	$supportedRequests = array('aid');


	function externalAuthentication()
	{
		global $authDB;

		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			if (isset($_GET['aid']))
			{
				$patient = getPID((string) $_GET['aid']);
				if ($patient != $_SESSION['login_patient'])
				{
					$_SESSION['login_patient'] = $patient;
					$authDB->logoff();
				}
			}
			else
			{
				$authDB->logoff();
			}
		}
		else
		{
			if (isset($_GET['aid']))
			{
				$authDB->logoff();
			}
		}
	}


	function externalLoginInfo(&$db, &$user, &$password)
	{
		//-------------------

		$showpatient_enabled = true;

		//-------------------

		$_SESSION['login_patient'] = "";
		$_SESSION['login_username'] = "";
		$_SESSION['login_usergroup'] = "";

		if ($showpatient_enabled)
		{
			global $authDB, $audit;

			if (isset($_GET['aid']))
			{
				unset($_SESSION['aid']);

				$aid = (string) $_GET['aid'];
				$patient = getPID($aid);
				if (!strlen($patient))
				{
					$db = "";
					$user = "";
					$password = "";
					$aid = $_GET['aid'];
					unset($_GET['aid']);
					$audit->log(false, "aid '$aid', " . $authDB->formatConnectDetails('', ''));
					$authDB->goHome(true, 'errorObjNotFound', 1, $aid, 'pacientas');
					exit;
				}
				if (($patient != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_patient'] = $patient;
					$audit->log("SUCCESS, patient '$patient'", "aid '$aid'");
				}
				return;
			}

			if (isset($_POST['aid']))
			{
				$aid = (string) $_POST['aid'];
				$patient = getPID($aid);
				if (!strlen($patient))
				{
					$db = "";
					$user = "";
					$password = "";
					$aid = $_POST['aid'];
					unset($_POST['aid']);
					$audit->log(false, "aid '$aid', " . $authDB->formatConnectDetails('', ''));
					$authDB->goHome(true, 'errorObjNotFound', 1, $aid, 'pacientas');
					exit;
				}
				if (($patient != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_post_patient'] = $patient;
					$audit->log("SUCCESS, patient '$patient'", "aid '$aid'");
				}
				return;
			}
		}
	}


	function externalPrivileges(&$privileges)
	{
		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			//$privileges['controlbar'] = false;
			$privileges['username'] = "";
			$privileges['closebutton'] = true;
			return;
		}

		if (isset($_SESSION['login_post_patient']) && ($_SESSION['login_post_patient'] != ""))
		{
			//$privileges['controlbar'] = false;
			$privileges['username'] = "";
			$privileges['closebutton'] = true;
			return;
		}
	}


	function externalActions(&$actions)
	{
		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "patient";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_patient'];
			return;
		}

		if (isset($_SESSION['login_post_patient']) && ($_SESSION['login_post_patient'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "patient";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_post_patient'];
			return;
		}
	}


	function getPID($aid)
	{
		global $authDB;

		if (!strlen($aid))
			return '';

		if (!$authDB->connect(SHOW_DB, SHOW_USER, SHOW_PASSWORD))
			return '';
		$sql = "SELECT pat_id FROM patient LEFT JOIN study ON study.patient_fk=patient.pk WHERE ref_physician='" .
			$authDB->sqlEscapeString($aid) . "^^^^' LIMIT 1";
		$rs = $authDB->query($sql);
		if (!$rs)
			return '';
		if ($row = $authDB->fetchNum($rs))
			return $row[0];
		return '';
	}
?>
