<?php
	define("SHOW_DB", "pacs2");		// PacsOne database
	define("SHOW_USER", "mduser");		// PacsOne user with view privileges
	define("SHOW_PASSWORD", "pacsmduser");	// user's password

	/* Requires to define supported request list */
	$supportedRequests = array('aid', 'study');


	function externalAuthentication()
	{
		global $authDB;

		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			if (isset($_GET['aid']))
			{
				$patient = getPID((string) $_GET['aid']);
				if ($patient != $_SESSION['login_patient'])
				{
					$_SESSION['login_patient'] = $patient;
					$authDB->logoff();
				}
			}
			else
			{
				$authDB->logoff();
			}
		}
		else
			if (isset($_SESSION['login_study']) && $_SESSION['login_study'] != "")
			{
				if (isset($_GET['study']))
				{
					$study = (string) $_GET['study'];
					if ($study != $_SESSION['login_study'])
					{
						$_SESSION['login_study'] = $study;
						$authDB->logoff();
					}
				}
				else
				{
					if (isset($_POST['study']))
					{
						$study = (string) $_POST['study'];
						if ($study != $_SESSION['login_study'])
						{
							$_SESSION['login_study'] = $study;
							$authDB->logoff();
						}
					}
					else
					{
						if (isset($_SESSION['login_post']))
						{
							unset($_SESSION['login_post']);
						}
						else
						{
							$authDB->logoff();
						}
					}
				}
			}
			else
				if (isset($_GET['aid']) || isset($_REQUEST['study']))
					$authDB->logoff();
	}


	function externalLoginInfo(&$db, &$user, &$password) 
	{
		//-------------------
		$showpatient_enabled = true;
		//-------------------

		$_SESSION['login_patient'] = "";
		$_SESSION['login_username'] = "";
		$_SESSION['login_usergroup'] = "";

		if ($showpatient_enabled)
		{
			global $authDB, $audit;

			if (isset($_GET['aid']))
			{
				unset($_SESSION['aid']);

				$aid = (string) $_GET['aid'];
				$patient = getPID($aid);
				if (($patient != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_patient'] = $patient;
					$audit->log("SUCCESS, patient '$patient'", "aid '$aid'");
				}
				else
				{
					$audit->log(false, "aid '$aid', " . $authDB->formatConnectDetails('', ''));
				}
				return;
			}

			if (isset($_POST['aid']))
			{
				$aid = (string) $_POST['aid'];
				$patient = getPID($aid);
				if (($patient != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_post_patient'] = $patient;
					$audit->log("SUCCESS, patient '$patient'", "aid '$aid'");
				}
				else
				{
					$audit->log(false, "aid '$aid', " . $authDB->formatConnectDetails('', ''));
				}
				return;
			}

			if (isset($_GET['study']))
			{
				$study = (string) $_GET['study'];
				if (($study != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_study'] = $study;
					if (!check_study_uid($study, $message, $fatal))
					{
						global $authDB;

						$db = "";
						$user = "";
						$password = "";
						unset($_GET['study']);
						unset($_SESSION['login_study']);
						$audit->log(false, "study '$study', " . $authDB->formatConnectDetails('', ''));
						$authDB->goHome(true, $message, $fatal, $study, 'study');
						exit;
					}
					else
					{
						$audit->log(true, "study '$study'");
					}
				}
				return;
			}

			if (isset($_POST['study']))
			{
				$study = (string) $_POST['study'];
				if (($study != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_study'] = $study;
					$_SESSION['login_post'] = true;
					if (!check_study_uid($study, $message, $fatal))
					{
						global $authDB;

						$db = "";
						$user = "";
						$password = "";
						unset($_POST['study']);
						unset($_SESSION['login_study']);
						$audit->log(false, "study '$study', " . $authDB->formatConnectDetails('', ''));
						$authDB->goHome(true, $message, $fatal, $study, 'study');
						exit;
					}
					else
					{
						$audit->log(true, "study '$study'");
					}
				}
				return;
			}
		}
	}


	function externalPrivileges(&$privileges)
	{
		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			//$privileges['controlbar'] = false;
			$privileges['username'] = "";
			$privileges['closebutton'] = true;
			return;
		}

		if (isset($_SESSION['login_post_patient']) && ($_SESSION['login_post_patient'] != ""))
		{
			//$privileges['controlbar'] = false;
			$privileges['username'] = "";
			$privileges['closebutton'] = true;
			return;
		}

		if (isset($_SESSION['login_username']) && ($_SESSION['login_username'] != ""))
			$privileges['username'] = $_SESSION['login_username'];
		if (isset($_SESSION['login_usergroup']) && ($_SESSION['login_usergroup'] == "Administrators"))
			$privileges['useradministration'] = true;
		else
			$privileges['useradministration'] = false;
	}


	function externalActions(&$actions)
	{
		if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "patient";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_patient'];
			return;
		}

		if (isset($_SESSION['login_post_patient']) && ($_SESSION['login_post_patient'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "patient";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_post_patient'];
			return;
		}

		if (isset($_SESSION['login_study']) && ($_SESSION['login_study'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "study";
			$actions['entry'] = array();
			$actions['entry'][0] = $_SESSION['login_study'];
			return;
		}
	}


	function getPID($aid)
	{
		global $log;

		$link = sqlsrv_connect('172.16.1.231', array('UID' => 'VYTAUT', 'PWD' => 'SmikiSmaki1717',
			'Database' => 'polis', 'LoginTimeout' => 15));
		if ($link === false)
		{
			$msg = '';
			$e = sqlsrv_errors();
			foreach ($e as $err)
				$msg .= '[' . $err['SQLSTATE'] . '] (' . $err['code'] . ') ' . $err['message'] . "\n";
			$log->asErr(__FUNCTION__ . '/sqlsrv_connect: ' . trim($msg));
			return '';
		}

		$query = sqlsrv_query($link, "SELECT TOP 1 ASM_ID,ASM_AK,ASM_PAVARDE,ASM_VARDAS FROM asmenys WHERE ASM_ID='".addslashes($aid)."' ORDER BY ASM_ID");
		if (!$query)
		{
			$msg = '';
			$e = sqlsrv_errors();
			foreach ($e as $err)
				$msg .= '[' . $err['SQLSTATE'] . '] (' . $err['code'] . ') ' . $err['message'] . "\n";
			$log->asErr(__FUNCTION__ . '/sqlsrv_query: ' . trim($msg));
			return '';
		}

		$pid = '';
		$row = sqlsrv_fetch_array($query, SQLSRV_FETCH_NUMERIC);
		if ($row)
			$pid = $row[1];

		return $pid;
	}


	function check_study_uid($uid, &$err, &$fatal)
	{
		global $authDB;
		global $log;

		$err = '';
		$fatal = 0;

		if (!$authDB->connect(SHOW_DB, SHOW_USER, SHOW_PASSWORD))
		{
			$err = 'errorValidateConnect';
			$fatal = 2;
			/*
				If SHOW_USER or SHOW_PASSWORD is invalid, only administrator
				can fix that by editing this file; can't offer the login
				form as credentials from it are used later and elsewhere.

				Error message is logged in AuthDB::connect().
			 */
			return false;
		}
		$sql = "SELECT private FROM study WHERE uuid='" . $authDB->sqlEscapeString($uid) . "'";
		$rs = $authDB->query($sql);
		if (!$rs)
		{
			$log->asErr(__FUNCTION__ . ": SQL error:'" . $authDB->getError() . "'");
			$err = 'errorValidateQuery';
			$fatal = 1;
			return false;
		}
		$row = $authDB->fetchNum($rs);
		if (!$row)
		{
			$err = 'errorObjNotFound';
			return false;
		}

		return true;
	}
?>
