<?php
/*
	Original name: external.php

	Copyright: Softneta, 2017

	Classification: public

	Owner: tb <tomas.burba@softneta.com>

	Contributors:
		kf <kestutis.freigofas@softneta.com>
		tb <tomas.burba@softneta.com>

	Description:
		HIS integration script for PacsOne. Supports linking by Image UID,
		Series UID, multiple objects. To be renamed to external.php.
 */

	define("SHOW_ENABLED", true);		// true: HIS integration is enabled; false: disabled
	define("SHOW_DB", "pacs");		// PacsOne database
	define("SHOW_USER", "user");		// PacsOne user with view privileges
	define("SHOW_PASSWORD", "password");	// user's password

	/**
	 * Requires to define supported request list
	 */
	$supportedRequests = array('study', 'patient', 'series', 'image');

	function externalAuthentication()
	{
		global $authDB;

		if (isset($_SESSION['login_study']) && $_SESSION['login_study'] != "")
		{
			if (isset($_GET['study']))
			{
				$study = (string) $_GET['study'];
				if ($study != $_SESSION['login_study'])
				{
					$_SESSION['login_study'] = $study;
					$authDB->logoff();
				}
			}
			else
			{
				if (isset($_POST['study']))
				{
					$study = (string) $_POST['study'];
					if ($study != $_SESSION['login_study'])
					{
						$_SESSION['login_study'] = $study;
						$authDB->logoff();
					}
				}
				else
				{
					if (isset($_SESSION['login_post']))
						unset($_SESSION['login_post']);
					else
						$authDB->logoff();
				}
			}
		}
		else
			if (isset($_SESSION['login_series']) && $_SESSION['login_series'] != "")
			{
				if (isset($_GET['series']))
				{
					$series = (string) $_GET['series'];
					if ($series != $_SESSION['login_series'])
					{
						$_SESSION['login_series'] = $series;
						$authDB->logoff();
					}
				}
				else
				{
					if (isset($_POST['series']))
					{
						$series = (string) $_POST['series'];
						if ($series != $_SESSION['login_series'])
						{
							$_SESSION['login_series'] = $series;
							$authDB->logoff();
						}
					}
					else
					{
						if (isset($_SESSION['login_post']))
							unset($_SESSION['login_post']);
						else
							$authDB->logoff();
					}
				}
			}
			else
				if (isset($_SESSION['login_image']) && $_SESSION['login_image'] != "")
				{
					if (isset($_GET['image']))
					{
						$image = (string) $_GET['image'];
						if ($image != $_SESSION['login_image'])
						{
							$_SESSION['login_image'] = $image;
							$authDB->logoff();
						}
					}
					else
					{
						if (isset($_POST['image']))
						{
							$image = (string) $_POST['image'];
							if ($image != $_SESSION['login_image'])
							{
								$_SESSION['login_image'] = $image;
								$authDB->logoff();
							}
						}
						else
						{
							if (isset($_SESSION['login_post']))
								unset($_SESSION['login_post']);
							else
								$authDB->logoff();
						}
					}
				}
				else
					if (isset($_SESSION['login_patient']) && $_SESSION['login_patient'] != "")
					{
						if (isset($_GET['patient']))
						{
							$patient = (string) $_GET['patient'];
							if ($patient != $_SESSION['login_patient'])
							{
								$_SESSION['login_patient'] = $patient;
								$authDB->logoff();
							}
						}
						else
						{
							if (isset($_POST['patient']))
							{
								$patient = (string) $_POST['patient'];
								if ($patient != $_SESSION['login_patient'])
								{
									$_SESSION['login_patient'] = $patient;
									$authDB->logoff();
								}
							}
							else
							{
								if (isset($_SESSION['login_post']))
									unset($_SESSION['login_post']);
								else
									$authDB->logoff();
							}
						}
					}
					else
						if (isset($_REQUEST['patient']))
							$authDB->logoff();
						else
							if (isset($_REQUEST['study']))
								$authDB->logoff();
							else
								if (isset($_REQUEST['series']))
									$authDB->logoff();
								else
									if (isset($_REQUEST['image']))
										$authDB->logoff();
	}

	function externalLoginInfo(&$db, &$user, &$password)
	{
		if (SHOW_ENABLED)
		{
			global $audit, $authDB;

			if (isset($_SESSION['login_image']))
				unset($_SESSION['login_image']);
			if (isset($_SESSION['login_series']))
				unset($_SESSION['login_series']);
			if (isset($_SESSION['login_study']))
				unset($_SESSION['login_study']);
			if (isset($_SESSION['login_patient']))
				unset($_SESSION['login_patient']);
			if (isset($_SESSION['login_post']))
				unset($_SESSION['login_post']);

			if (isset($_GET['study']))
			{
				$study = (string) $_GET['study'];
				if (($study != "") && (isset($user)) && ($user == ""))
				{
					$db = SHOW_DB;
					$user = SHOW_USER;
					$password = SHOW_PASSWORD;
					$_SESSION['login_study'] = $study;

					if (!check_study_uid($study, $message, $fatal))
					{
						$db = "";
						$user = "";
						$password = "";
						unset($_GET['study']);
						$audit->log(false, "study '$study', " . $authDB->formatConnectDetails('', ''));
						$authDB->goHome(true, $message, $fatal, $study, 'study');
					}
					else
						$audit->log(true, "study '$study'");
				}
			}
			else
				if (isset($_POST['study']))
				{
					$study = (string) $_POST['study'];
					if (($study != "") && (isset($user)) && ($user == ""))
					{
						$db = SHOW_DB;
						$user = SHOW_USER;
						$password = SHOW_PASSWORD;
						$_SESSION['login_study'] = $study;
						$_SESSION['login_post'] = true;

						if (!check_study_uid($study, $message, $fatal))
						{
							$db = "";
							$user = "";
							$password = "";
							unset($_POST['study']);
							$audit->log(false, "study '$study', " . $authDB->formatConnectDetails('', ''));
							$authDB->goHome(true, $message, $fatal, $study, 'study');
						}
						else
							$audit->log(true, "study '$study'");
					}
				}
				else
					if (isset($_GET['series']))
					{
						$series = (string) $_GET['series'];
						if (($series != "") && (isset($user)) && ($user == ""))
						{
							$db = SHOW_DB;
							$user = SHOW_USER;
							$password = SHOW_PASSWORD;
							$_SESSION['login_series'] = $series;

							if (!check_series_uid($series, $message, $fatal))
							{
								$db = "";
								$user = "";
								$password = "";
								unset($_GET['series']);
								$audit->log(false, "series '$series', " . $authDB->formatConnectDetails('', ''));
								$authDB->goHome(true, $message, $fatal, $series, 'series');
							}
							else
								$audit->log(true, "series '$series'");
						}
					}
					else
						if (isset($_POST['series']))
						{
							$series = (string) $_POST['series'];
							if (($series != "") && (isset($user)) && ($user == ""))
							{
								$db = SHOW_DB;
								$user = SHOW_USER;
								$password = SHOW_PASSWORD;
								$_SESSION['login_series'] = $series;
								$_SESSION['login_post'] = true;

								if (!check_series_uid($series, $message, $fatal))
								{
									$db = "";
									$user = "";
									$password = "";
									unset($_POST['series']);
									$audit->log(false, "series '$series', " . $authDB->formatConnectDetails('', ''));
									$authDB->goHome(true, $message, $fatal, $series, 'series');
								}
								else
									$audit->log(true, "series '$series'");
							}
						}
						else
							if (isset($_GET['image']))
							{
								$image = (string) $_GET['image'];
								if (($image != "") && (isset($user)) && ($user == ""))
								{
									$db = SHOW_DB;
									$user = SHOW_USER;
									$password = SHOW_PASSWORD;
									$_SESSION['login_image'] = $image;

									if (!check_image_uid($image, $message, $fatal))
									{
										$db = "";
										$user = "";
										$password = "";
										unset($_GET['image']);
										$audit->log(false, "image '$image', " . $authDB->formatConnectDetails('', ''));
										$authDB->goHome(true, $message, $fatal, $image, 'image');
									}
									else
										$audit->log(true, "image '$image'");
								}
							}
							else
								if (isset($_POST['image']))
								{
									$image = (string) $_POST['image'];
									if (($image != "") && (isset($user)) && ($user == ""))
									{
										$db = SHOW_DB;
										$user = SHOW_USER;
										$password = SHOW_PASSWORD;
										$_SESSION['login_image'] = $image;
										$_SESSION['login_post'] = true;

										if (!check_image_uid($image, $message, $fatal))
										{
											$db = "";
											$user = "";
											$password = "";
											unset($_POST['image']);
											$audit->log(false, "image '$image', " . $authDB->formatConnectDetails('', ''));
											$authDB->goHome(true, $message, $fatal, $image, 'image');
										}
										else
											$audit->log(true, "image '$image'");
									}
								}
								else
									if (isset($_GET['patient']))
									{
										$patient = (string) $_GET['patient'];
										if (($patient != "") && (isset($user)) && ($user == ""))
										{
											$db = SHOW_DB;
											$user = SHOW_USER;
											$password = SHOW_PASSWORD;
											$_SESSION['login_patient'] = $patient;

											if (!check_patient_uid($patient, $message, $fatal))
											{
												$db = "";
												$user = "";
												$password = "";
												unset($_GET['patient']);
												$audit->log(false, "patient '$patient', " . $authDB->formatConnectDetails('', ''));
												$authDB->goHome(true, $message, $fatal, $patient, 'patient');
											}
											else
												$audit->log(true, "patient '$patient'");
										}
									}
									else
										if (isset($_POST['patient']))
										{
											$patient = (string) $_POST['patient'];
											if (($patient != "") && (isset($user)) && ($user == ""))
											{
												$db = SHOW_DB;
												$user = SHOW_USER;
												$password = SHOW_PASSWORD;
												$_SESSION['login_patient'] = $patient;
												$_SESSION['login_post'] = true;

												if (!check_patient_uid($patient, $message, $fatal))
												{
													$db = "";
													$user = "";
													$password = "";
													unset($_POST['patient']);
													$audit->log(false, "patient '$patient', " . $authDB->formatConnectDetails('', ''));
													$authDB->goHome(true, $message, $fatal, $patient, 'patient');
												}
												else
													$audit->log(true, "patient '$patient'");
											}
										}

			/* also provide login credentials for imagejpeg.php */
			GLOBAL $imagejpeg;
			if (isset($imagejpeg) && $imagejpeg)	/* defined and initialized only there */
			{
				GLOBAL $imagejpegsize;
				$db = SHOW_DB;
				$user = SHOW_USER;
				$password = SHOW_PASSWORD;
				$imagejpegsize = 1024;
			}
		}
	}

	function externalPrivileges(&$privileges)
	{
		if ((isset($_SESSION['login_study']) && ($_SESSION['login_study'] != "")) ||
				(isset($_SESSION['login_series']) && ($_SESSION['login_series'] != "")) ||
				(isset($_SESSION['login_image']) && ($_SESSION['login_image'] != "")) ||
				(isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != "")))
			$privileges['closebutton'] = true;
	}

	function externalActions(&$actions)
	{
		if (isset($_SESSION['login_study']) && ($_SESSION['login_study'] != ""))
		{
			$actions = array();
			$actions['action'] = "Show";
			$actions['option'] = "study";
			$actions['entry'] = array();
			$actions['entry'] = explode(';',$_SESSION['login_study']);
		}
		else
			if (isset($_SESSION['login_series']) && ($_SESSION['login_series'] != ""))
			{
				$actions = array();
				$actions['action'] = "Show";
				$actions['option'] = "series";
				$actions['entry'] = array();
				$actions['entry'] = explode(';',$_SESSION['login_series']);
			}
			else
				if (isset($_SESSION['login_image']) && ($_SESSION['login_image'] != ""))
				{
					$actions = array();
					$actions['action'] = "Show";
					$actions['option'] = "image";
					$actions['entry'] = array();
					$actions['entry'] = explode(';',$_SESSION['login_image']);
				}
				else
					if (isset($_SESSION['login_patient']) && ($_SESSION['login_patient'] != ""))
					{
						$actions = array();
						$actions['action'] = "Show";
						$actions['option'] = "patient";
						$actions['entry'] = array();
						$actions['entry'][0] = $_SESSION['login_patient'];
					}
	}

	function check_study_uid($uid, &$err, &$fatal)
	{
		global $backend, $authDB, $log;

		$err = '';
		$fatal = 0;

		if (!$authDB->connect(SHOW_DB, SHOW_USER, SHOW_PASSWORD))
		{
			$err = 'errorValidateConnect';
			$fatal = 2;
			return false;
		}

		$uid = $authDB->sqlEscapeString($uid);
		$uid = str_replace(',', ';', $uid);
		$uids = explode(';', $uid);
		$uid = "('" . join("','", $uids) . "')";//('uid','uid')
		$col = $backend->getPacsConfigPrm('F_STUDY_UUID');
		$sql = "SELECT private FROM study WHERE $col IN $uid";
		$rs = $authDB->query($sql);
		if (!$rs)
		{
			$log->asErr("SQL error: '" . $authDB->getError() . "'");
			$err = 'errorValidateQuery';
			$fatal = 1;
			return false;
		}

		if ($row = $authDB->fetchAssoc($rs))
			return true;

		$err = 'errorObjNotFound';
		return false;
	}

	function check_series_uid($uid, &$err, &$fatal)
	{
		global $backend, $authDB, $log;

		$err = '';
		$fatal = 0;

		if (!$authDB->connect(SHOW_DB, SHOW_USER, SHOW_PASSWORD))
		{
			$err = 'errorValidateConnect';
			$fatal = 2;
			return false;
		}

		$uid = str_replace(',', ';', $uid);
		$uid = $authDB->sqlEscapeString($uid);
		$uid = str_replace(',', ';', $uid);
		$uids = explode(';', $uid);
		$uid = "('" . join("','", $uids) . "')";//('uid','uid')
		$col = $backend->getPacsConfigPrm('F_SERIES_UUID');
		$sql = "SELECT instances FROM series WHERE $col IN $uid";
		$rs = $authDB->query($sql);
		if (!$rs)
		{
			$log->asErr("SQL error: '" . $authDB->getError() . "'");
			$err = 'errorValidateQuery';
			$fatal = 1;
			return false;
		}

		if ($row = $authDB->fetchAssoc($rs))
			return true;

		$err = 'errorObjNotFound';
		return false;
	}

	function check_image_uid($uid, &$err, &$fatal)
	{
		global $backend, $authDB, $log;

		$err = '';
		$fatal = 0;

		if (!$authDB->connect(SHOW_DB, SHOW_USER, SHOW_PASSWORD))
		{
			$err = 'errorValidateConnect';
			$fatal = 2;
			return false;
		}

		$uid = str_replace(',', ';', $uid);
		$uid = $authDB->sqlEscapeString($uid);
		$uid = str_replace(',', ';', $uid);
		$uids = explode(';', $uid);
		$uid = "('" . join("','", $uids) . "')";//('uid','uid')
		$col = $backend->getPacsConfigPrm('F_IMAGE_UUID');
		$sql = "SELECT seriesuid FROM image WHERE $col IN $uid";
		$rs = $authDB->query($sql);
		if (!$rs)
		{
			$log->asErr("SQL error: '" . $authDB->getError() . "'");
			$err = 'errorValidateQuery';
			$fatal = 1;
			return false;
		}

		if ($row = $authDB->fetchAssoc($rs))
			return true;

		$err = 'errorObjNotFound';
		return false;
	}

	function check_patient_uid($uid, &$err, &$fatal)
	{
		global $authDB, $log;

		$err = '';
		$fatal = 0;

		if (!$authDB->connect(SHOW_DB, SHOW_USER, SHOW_PASSWORD))
		{
			$err = 'errorValidateConnect';
			$fatal = 2;
			return false;
		}

		$sql = "SELECT private FROM patient WHERE origid='" . $authDB->sqlEscapeString($uid) . "'";
		$rs = $authDB->query($sql);
		if (!$rs)
		{
			$log->asErr("SQL error: '" . $authDB->getError() . "'");
			$err = 'errorValidateQuery';
			$fatal = 1;
			return false;
		}

		if ($row = $authDB->fetchAssoc($rs))
			return true;

		$err = 'errorObjNotFound';
		return false;
	}
?>
